//*********************************************************************
//*  Programmer    : Jang Kyu-O                                       *
//*  Date          : 1995/12/21                                       *
//*  E-Mail        : kojang@ctkhost.ctk.co.kr                         *
//*  Tel           : (02) 3149-4821                                   *
//*  Address       : ̾ Ʈ                    *
//*********************************************************************

import java.applet.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import java.net.*;

import Description;
import ScreenInfo;

/**********************************************************************
 * ̹ ȭ Ʈ ִ ȭ о
 *  ̹ ȭ оδ.
 **********************************************************************/
class ImageComponent {
    Applet    parent;
    // ̹ ȭ Document base Ǵ URL
    URL       docBase;

    // ̹ ȭ .
    int       num;

    // ̹ ȭ ŭ ޸𸮸 Ҵ޾
    //  ̹ ȭ ޸𸮿 Ѵ.
    Image     member[];

    // Document Base, ̹ Ʈ ȭ ̸ ޾Ƶд.
    ImageComponent(Applet p, int n) {
        parent      = p;

        docBase     = parent.getDocumentBase();
        num         = n;

        // ̹ ȭ ŭ ޸𸮸 ҴѴ.
        member = new Image[num];
    }

    // ̹ȭ о´.
    public boolean setMember(String name, int row){
        if(row >= num) {
            System.out.println("Image Index too big : ");
            return false;
        }

        try {
            member[row] = parent.getImage(new URL(docBase, name));
        } catch(Exception e) {
            System.out.println(docBase+"/"+name+" file not found : "+e);
            return false;
        }
        return true;
    }

    public Image getMember(int row) {
        if(row >= num) {
            System.out.println("Image Index too big : ");
            return null;
        }
        return member[row];
    }
}

/*********************************************************************
 * ϳ ŸƲ   
 * Ѵ.
 *********************************************************************/
class DescriptionSet {
    //   ޸.
    Description document[];

    //  .
    int         nummember;

    //   ޸ Ҵ.
    public DescriptionSet(int num) {
        nummember = num;
        document = new Description[nummember];
        for(int i=0 ; i<nummember ; i++) {
            document[i] = new Description();
        }
    }

    // ϳ   .
    private void setScriptColor(String line, int row) {
        String token;
        int    index, cur;

        cur    = 0;
        int    c[] = new int[3];

        // ',' ڷ Ͽ RGB .
        for(int i=0 ; i<3 ; i++) {
            index = line.indexOf(',', cur);
            if(index == -1) index=line.length();
            token = line.substring(cur, index);
            c[i] = Integer.parseInt(token);
            cur = index+1;
        }

        document[row].col = new Color(c[0], c[1], c[2]);
    }

    // ϳ  ġ .
    private void setScriptPosition(String line, int row) {
        String token;
        int    index, cur;

        cur    = 0;
        int    p[] = new int[2];

        // ',' ڷ Ͽ X, Yġ Ѵ.
        for(int i=0 ; i<2 ; i++) {
            index = line.indexOf(',', cur);
            if(index == -1) index=line.length();
            token = line.substring(cur, index);
            p[i] = Integer.parseInt(token);
            cur = index+1;
        }

        document[row].position_x = p[0];
        document[row].position_y = p[1];
    }

    //  Ʈ ũ⸦ Ѵ.
    private void setScriptSize(String line, int row) {
        document[row].size = Integer.parseInt(line);
    }

    //   Ѵ.
    private void setScriptContent(String line, int row) {
        document[row].content = line;
    }

    // ϳ 忡 Ͽ, , ġ, ũ,  Ѵ.
    public boolean setDescription(String line, int row) {
        if(row>=nummember) return false;

        String token;
        int    index, cur;

        // '+' ڷ Ͽ  Ѵ.
        cur    = 0;
        index = line.indexOf('+', cur);
        if(index == -1) return false;
        token = line.substring(cur, index);
        setScriptColor(token, row);
        cur = index+1;

        // '+' ڷ Ͽ ġ Ѵ.
        index = line.indexOf('+', cur);
        if(index == -1) return false;
        token = line.substring(cur, index);
        setScriptPosition(token, row);
        cur = index+1;

        // '+' ڷ Ͽ ũ Ѵ.
        index = line.indexOf('+', cur);
        if(index == -1) return false;
        token = line.substring(cur, index);
        setScriptSize(token, row);
        cur = index+1;

        // '+' ڷ Ͽ  Ѵ.
        index = line.length();
        token = line.substring(cur, index);
        setScriptContent(token, row);

        return true;
    }

    public String getScriptContent(int row) {
        if(row>=nummember) return null;
        return document[row].content;
    }
    public Color getScriptColor(int row) {
        if(row>=nummember) return Color.white;
        return document[row].col;
    }
    public int getScriptSize(int row) {
        if(row>=nummember) return 10;
        return document[row].size;
    }
    public int getScriptX(int row) {
        if(row>=nummember) return 0;
        return document[row].position_x;
    }
    public int getScriptY(int row) {
        if(row>=nummember) return 0;
        return document[row].position_y;
    }
    public int getNumMember() {
        return nummember;
    }
}

/********************************************************************
 * ü ŸƲ ̹,  Ѵ.
 ********************************************************************/
class TitleComponent {
    Applet         parent;
    // ũƮȭ URL ´.
    URL            scriptFile;

    // Document base Ǵ URL
    URL            docBase;

    //  ŸƲ ̹  Ѵ.
    int            numTitle;    
    ImageComponent grim;
    DescriptionSet data[];

    // ũƮ URL ,
    // ̹ȭ  ޸Ȯ
    // ŸƲ   ޸𸮸 ȮѴ.
    public TitleComponent(Applet p, String script, int num) {
        parent      = p;

        docBase     = parent.getDocumentBase();
        numTitle    = num;

        try {
            scriptFile = new URL(docBase, script);
        } catch(Exception e) {
            System.out.println(docBase+"/"+script+" not found : "+e);
            return;
        }

        grim = new ImageComponent(parent, numTitle);
        data = new DescriptionSet[numTitle];
    }

    // "begin" ϴ ϳ ŸƲ ϰ
    // ŸƲ    ˾Ƴ.
    private int readHead(DataInputStream in) {
        String line = null;

        while(true) {
            try {
                line = in.readLine();
            } catch(Exception e) {
                System.out.println("Script file read error : "+e);
            }
            if( line.equalsIgnoreCase("begin") == true) {
                try {
                    line = in.readLine();
                } catch(Exception e) {
                    System.out.println("Script file read error : "+e);
                }
                return Integer.parseInt(line);
            }
        }
    }

    public boolean setTitleComponent() {
        // ũƮ ȭ о´.
        // begin
        //      .
        //     ̹ ȭ.
        //     ,ġ,Ʈũ,
        //     ..........
        //     ,ġ,Ʈũ,
        // end
        //  ũƮ ȭ ̾ Ѵ.
        DataInputStream in;
        try {
            in = new DataInputStream(scriptFile.openStream());
        } catch(Exception e) {
            System.out.println(scriptFile+" open error : "+e);
            return false;
        }

        String line=null;
        // ŸƲ ŭ д´.
        for(int i=0 ; i<numTitle ; i++) {
            // "begin" а,   д´.
            int numline = readHead(in);
            //  ŭ ޸𸮸 ҴѴ.
            data[i] = new DescriptionSet(numline);

            // ̹ ȭ о´.
            try {
                line = in.readLine();
            } catch(Exception e) {
                System.out.println("Script file read error : "+e);
            }
            grim.setMember(line, i);
            System.out.println("debug head, Images : "+numline+" "+line);

            //   о,  Ѵ.
            int count = 0;
            while(true) {
                try {
                    line = in.readLine();
                } catch(Exception e) {
                    System.out.println("Script file read error : "+e);
                }
                // "end"  ´.
                if( line.equalsIgnoreCase("end") == true)
                    break;
                //   Ѵ.
                data[i].setDescription(line, count++);
            }
        }
        return true;
    }

    public Image getTitleImage(int row) {
        return grim.getMember(row);
    }
    public String getContent(int row, int index) {
        return data[row].getScriptContent(index);
    }
    public Color getColor(int row, int index) {
        return data[row].getScriptColor(index);
    }
    public int getSize(int row, int index) {
        return data[row].getScriptSize(index);
    }
    public int getX(int row, int index) {
        return data[row].getScriptX(index);
    }
    public int getY(int row, int index) {
        return data[row].getScriptY(index);
    }
    public int getNumMember(int row) {
        return data[row].getNumMember();
    }
}

/********************************************************************
 *  ø.!!!
 ********************************************************************/
public class AdvertiseScroller extends Applet implements Runnable
{
    //  ߿ ü!
    Thread           cthread;
    TitleComponent   title;
    ScreenInfo       info[];

    // ũƮȭ, ȭũ, ŸƲ , ׸, Ʈ ӵ..
    // ø Ķͷ ޴°͵.
    String           scriptFile;
    int              width, height;
    int              numTitle;
    URL              bgURL;
    int              delay;

    // ø  ǥø  .
    boolean          beginning;
    boolean          inapplet; 
    boolean          inupdate;
    String           currURL = "Advertise Scroller Java Applet Ver 1.0 Jang Kyu-O. 1-22-96";

    // ȭó  ̹, ̹, ޸ ̹.
    Image            coolimg, bgimg;
    Graphics         coolmap;
    Color            bgcolor;

    // ȭ ǥ,   .
    int              function;
    int              startPos;
    int              TotalLength;
    int              backWidth = 913;

    // ø .
    public String getAppletInfo() {
        return "Advertise Scroller Java Applet Ver 1.0 Jang Kyu-O. 1-22-96";
    }

    // HTML ± Ķ .
    public String[][] getParameterInfo() {
        String[][] info = {
            {"script",     "url", "Advertize Scroller Java Applet Scriptfile"},
            {"width",      "int", "Applet width"},
            {"height",     "int", "Applet height"},
            {"background", "url", "Background Image"},
            {"numtitle",   "int", "The Number of Title"},
            {"delay",      "int", "Update delay speed"}
        };
        return info;
    }

    // HTMLȭ Ķ͸ о´.
    private void getAttrs() {
        width = Integer.parseInt(getParameter("width"));
        height = Integer.parseInt(getParameter("height"));
        numTitle = Integer.parseInt(getParameter("numtitle"));
        delay = Integer.parseInt(getParameter("delay"));
        
        try {
            bgURL = new URL(getDocumentBase(), getParameter("background"));
        } catch(Exception e) {
            System.out.println("Background Image file fail : "+e);
        }

        scriptFile = getParameter("script");
    }

    // ø ʱȭ Ѵ.
    public void init() {
        inupdate        = false;
        beginning       = true;

        bgcolor         = Color.white;

        getAttrs();

        function        = 0;
        startPos        = height;

        title = new TitleComponent(this, scriptFile, numTitle);
        title.setTitleComponent();

        info = new ScreenInfo[numTitle];
        int imageHeight = 150;
        int imageWidth  = 150;
        TotalLength = 0;
        for(int i=0 ; i<numTitle ; i++) {
            info[i] = new ScreenInfo();
            info[i].titleHeight = imageHeight;
            info[i].curPosition = height+imageHeight*i;
            info[i].devidePosition = imageWidth;
            TotalLength += imageHeight;
        }

        setBackground(Color.lightGray);
    }

    // ø Ʈ .
    public void start() {
       if(cthread == null) {
           cthread = new Thread(this);  // Start the applet running
           cthread.start();
       }
    }

    //  .
    public void stop() {
        cthread = null;
    }

    //  .
    public void run() {
        cthread.setPriority(Thread.MAX_PRIORITY);
        while(cthread != null) {
            repaint();

            try {
                cthread.sleep(delay);
            } catch (InterruptedException e) {
            }
        }
    }

    // 콺  ¹ٿ ø  ش.
    public boolean mouseEnter(java.awt.Event evt, int x, int y) {
        inapplet = true;

        showStatus(currURL);

        return true;
    }

    // 콺  ¹ ø  .
    public boolean mouseExit(java.awt.Event evt, int x, int y) {
        inapplet = false;
      
        showStatus(" ");

        return true;
    }

    //  .
    private void setBatang(Graphics g) {
        g.setColor(bgcolor);
        g.fillRect(0, 0, width, height);
    }

    // ȭʱȭ.
    public void paint(Graphics g) {
        if(beginning) {
            coolimg = createImage(width, height);
            coolmap = coolimg.getGraphics();
            bgimg = getImage(bgURL);

            setBatang(coolmap);
            coolmap.drawImage(bgimg, 0, 0, this);
            g.drawImage(coolimg, 0, 0, this);
            beginning = false;
        } else {
            setBatang(coolmap);
            coolmap.drawImage(bgimg, 0, 0, this);
            g.drawImage(coolimg, 0, 0, this);
        }
    }

    int scrollindex=0;
    private void ScrollBack(Graphics g) {
        scrollindex++;
        if(scrollindex>backWidth-1)
            scrollindex = 0;

        g.drawImage(bgimg, scrollindex, 0, this);
        g.drawImage(bgimg, scrollindex-backWidth+1, 0, this);
    }

    private void ScrollTitle(Graphics g) {
        for(int i=0 ; i<numTitle ; i++) {
            info[i].curPosition--;
            if(info[i].curPosition < (-TotalLength+1+height))
                info[i].curPosition=height;
        }
        for(int i=0 ; i<numTitle ; i++) {
            if(info[i].curPosition<height)
                if(info[i].curPosition>-height)
                    g.drawImage(title.getTitleImage(i), 10, info[i].curPosition, this);

            for(int j=0 ; j<title.getNumMember(i) ; j++) {
                if(info[i].curPosition+title.getY(i, j)<height+title.getSize(i, j)) {
                    if(info[i].curPosition+title.getY(i, j)>-title.getSize(i, j)) {
                        g.setFont(new Font("Times New Roman", 1, title.getSize(i, j)));
                        g.setColor(title.getColor(i, j));
                        g.drawString(title.getContent(i, j),
                                     title.getX(i, j),
                                     info[i].curPosition+title.getY(i, j));
                                     // info[i].devidePosition+title.getX(i, j),
                                     // info[i].curPosition+title.getY(i, j));
                    }
                }
            }
        }
    }

    // ȭ  Լ.
    public void update(Graphics g) {
        setBatang(coolmap);
        ScrollBack(coolmap);
        ScrollTitle(coolmap);
        g.drawImage(coolimg, 0, 0, this);
    }
}
